/*
 * WSO2 API Manager - Publisher API
 * This specifies a **RESTful API** for WSO2 **API Manager** - Publisher.  Please see [full swagger definition](https://raw.githubusercontent.com/wso2/carbon-apimgt/v6.0.4/components/apimgt/org.wso2.carbon.apimgt.rest.api.publisher/src/main/resources/publisher-api.yaml) of the API which is written using [swagger 2.0](http://swagger.io/) specification. 
 *
 * OpenAPI spec version: v1.0
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.publisher.api.v1.dto;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * ExternalStoreDTO
 */

public class ExternalStoreDTO {
  @SerializedName("id")
  private String id = null;

  @SerializedName("displayName")
  private String displayName = null;

  @SerializedName("type")
  private String type = null;

  @SerializedName("endpoint")
  private String endpoint = null;

  public ExternalStoreDTO id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The external store identifier, which is a unique value. 
   * @return id
  **/
  @ApiModelProperty(example = "Store123#", value = "The external store identifier, which is a unique value. ")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public ExternalStoreDTO displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * The name of the external API Store that is displayed in the Publisher UI. 
   * @return displayName
  **/
  @ApiModelProperty(example = "UKStore", value = "The name of the external API Store that is displayed in the Publisher UI. ")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

  public ExternalStoreDTO type(String type) {
    this.type = type;
    return this;
  }

   /**
   * The type of the Store. This can be a WSO2-specific API Store or an external one. 
   * @return type
  **/
  @ApiModelProperty(example = "wso2", value = "The type of the Store. This can be a WSO2-specific API Store or an external one. ")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public ExternalStoreDTO endpoint(String endpoint) {
    this.endpoint = endpoint;
    return this;
  }

   /**
   * The endpoint URL of the external store 
   * @return endpoint
  **/
  @ApiModelProperty(example = "http://localhost:9764/store", value = "The endpoint URL of the external store ")
  public String getEndpoint() {
    return endpoint;
  }

  public void setEndpoint(String endpoint) {
    this.endpoint = endpoint;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ExternalStoreDTO externalStore = (ExternalStoreDTO) o;
    return Objects.equals(this.id, externalStore.id) &&
        Objects.equals(this.displayName, externalStore.displayName) &&
        Objects.equals(this.type, externalStore.type) &&
        Objects.equals(this.endpoint, externalStore.endpoint);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, displayName, type, endpoint);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ExternalStoreDTO {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    endpoint: ").append(toIndentedString(endpoint)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

